// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login service
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package login

import (
	"context"
)

// Login Service enables authorization for user
type Service interface {
	// Login creates a JWT token for a given email and sends it to the user.
	Login(context.Context, *LoginRequest) (res *LoginResult, err error)
	// LoginInvitation asks the OCM for proof invitation link which can be
	// displayed for scanning by PCM.
	LoginInvitation(context.Context) (res *LoginInvitationResult, err error)
	// LoginWithVC receives presentationId and creates a JWT after receiving valid
	// proof object from the OCM.
	LoginWithVC(context.Context, *LoginVCRequest) (res *LoginVCResult, err error)
	// Keys returns a list of public keys used for verification of JWT issued by
	// login.
	Keys(context.Context) (res *KeysResult, err error)
}

// ServiceName is the name of the service as defined in the design. This is the
// same value that is set in the endpoint request contexts under the ServiceKey
// key.
const ServiceName = "login"

// MethodNames lists the service method names as defined in the design. These
// are the same values that are set in the endpoint request contexts under the
// MethodKey key.
var MethodNames = [4]string{"Login", "LoginInvitation", "LoginWithVC", "Keys"}

// KeysResult is the result type of the login service Keys method.
type KeysResult struct {
	// List of public keys.
	Keys []any
}

// LoginInvitationResult is the result type of the login service
// LoginInvitation method.
type LoginInvitationResult struct {
	// Identifier of the proof invitation request.
	ProofRecordID string
	// Link containing the invitation proof request which the PCM can scan to login.
	PresentationMessage string
	// Shortened URL link which the PCM can scan to login.
	PresentationMessageShort string
	// Timestamp for when the invitation was created.
	CreatedDate string
}

// LoginRequest is the payload type of the login service Login method.
type LoginRequest struct {
	Email string
}

// LoginResult is the result type of the login service Login method.
type LoginResult struct {
	// Status message response.
	Message string
}

// LoginVCRequest is the payload type of the login service LoginWithVC method.
type LoginVCRequest struct {
	ProofRecordID string
}

// LoginVCResult is the result type of the login service LoginWithVC method.
type LoginVCResult struct {
	// Token in JWT format after successful login.
	Token any
}
